import { defineMiddleware } from "astro:middleware";
import { Split } from "./core";

// Get/Set split cookie and put it on the Astro object
export const onRequest = defineMiddleware(async (context, next) => {

    let split: Split;

    // see if we are already running a split
    let cookie = context.cookies.get("split")
    if (!cookie) { // no split detected
	    let i = Math.floor(Math.random() * Object.keys(Split).length);
	    split = Object.values(Split)[i] as Split;

	    context.cookies.set("split", Split[split])
    } else { // split detected!
        let v = cookie.value;
    	split = v as unknown as Split;
    }

    context.locals.split = split

    return next()
})